Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 1 | #!/bin/sh |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 2 | # |
| 3 | # install - install a program, script, or datafile |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 4 | # This comes from X11R5 (mit/util/scripts/install.sh). |
| 5 | # |
| 6 | # Copyright 1991 by the Massachusetts Institute of Technology |
| 7 | # |
| 8 | # Permission to use, copy, modify, distribute, and sell this software and its |
| 9 | # documentation for any purpose is hereby granted without fee, provided that |
| 10 | # the above copyright notice appear in all copies and that both that |
| 11 | # copyright notice and this permission notice appear in supporting |
| 12 | # documentation, and that the name of M.I.T. not be used in advertising or |
| 13 | # publicity pertaining to distribution of the software without specific, |
| 14 | # written prior permission. M.I.T. makes no representations about the |
| 15 | # suitability of this software for any purpose. It is provided "as is" |
| 16 | # without express or implied warranty. |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 17 | # |
| 18 | # Calling this script install-sh is preferred over install.sh, to prevent |
| 19 | # `make' implicit rules from creating a file called install from it |
| 20 | # when there is no Makefile. |
| 21 | # |
| 22 | # This script is compatible with the BSD install script, but was written |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 23 | # from scratch. It can only install one file at a time, a restriction |
| 24 | # shared with many OS's install programs. |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 25 | |
| 26 | |
| 27 | # set DOITPROG to echo to test this script |
| 28 | |
| 29 | # Don't use :- since 4.3BSD and earlier shells don't like it. |
| 30 | doit="${DOITPROG-}" |
| 31 | |
| 32 | |
| 33 | # put in absolute paths if you don't have them in your path; or use env. vars. |
| 34 | |
| 35 | mvprog="${MVPROG-mv}" |
| 36 | cpprog="${CPPROG-cp}" |
| 37 | chmodprog="${CHMODPROG-chmod}" |
| 38 | chownprog="${CHOWNPROG-chown}" |
| 39 | chgrpprog="${CHGRPPROG-chgrp}" |
| 40 | stripprog="${STRIPPROG-strip}" |
| 41 | rmprog="${RMPROG-rm}" |
| 42 | mkdirprog="${MKDIRPROG-mkdir}" |
| 43 | |
| 44 | transformbasename="" |
| 45 | transform_arg="" |
| 46 | instcmd="$mvprog" |
| 47 | chmodcmd="$chmodprog 0755" |
| 48 | chowncmd="" |
| 49 | chgrpcmd="" |
| 50 | stripcmd="" |
| 51 | rmcmd="$rmprog -f" |
| 52 | mvcmd="$mvprog" |
| 53 | src="" |
| 54 | dst="" |
| 55 | dir_arg="" |
| 56 | |
| 57 | while [ x"$1" != x ]; do |
| 58 | case $1 in |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 59 | -c) instcmd=$cpprog |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 60 | shift |
| 61 | continue;; |
| 62 | |
| 63 | -d) dir_arg=true |
| 64 | shift |
| 65 | continue;; |
| 66 | |
| 67 | -m) chmodcmd="$chmodprog $2" |
| 68 | shift |
| 69 | shift |
| 70 | continue;; |
| 71 | |
| 72 | -o) chowncmd="$chownprog $2" |
| 73 | shift |
| 74 | shift |
| 75 | continue;; |
| 76 | |
| 77 | -g) chgrpcmd="$chgrpprog $2" |
| 78 | shift |
| 79 | shift |
| 80 | continue;; |
| 81 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 82 | -s) stripcmd=$stripprog |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 83 | shift |
| 84 | continue;; |
| 85 | |
| 86 | -t=*) transformarg=`echo $1 | sed 's/-t=//'` |
| 87 | shift |
| 88 | continue;; |
| 89 | |
| 90 | -b=*) transformbasename=`echo $1 | sed 's/-b=//'` |
| 91 | shift |
| 92 | continue;; |
| 93 | |
| 94 | *) if [ x"$src" = x ] |
| 95 | then |
| 96 | src=$1 |
| 97 | else |
| 98 | # this colon is to work around a 386BSD /bin/sh bug |
| 99 | : |
| 100 | dst=$1 |
| 101 | fi |
| 102 | shift |
| 103 | continue;; |
| 104 | esac |
| 105 | done |
| 106 | |
| 107 | if [ x"$src" = x ] |
| 108 | then |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 109 | echo "$0: no input file specified" >&2 |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 110 | exit 1 |
| 111 | else |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 112 | : |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 113 | fi |
| 114 | |
| 115 | if [ x"$dir_arg" != x ]; then |
| 116 | dst=$src |
| 117 | src="" |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 118 | |
| 119 | if [ -d "$dst" ]; then |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 120 | instcmd=: |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 121 | chmodcmd="" |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 122 | else |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 123 | instcmd=$mkdirprog |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 124 | fi |
| 125 | else |
| 126 | |
| 127 | # Waiting for this to be detected by the "$instcmd $src $dsttmp" command |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 128 | # might cause directories to be created, which would be especially bad |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 129 | # if $src (and thus $dsttmp) contains '*'. |
| 130 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 131 | if [ -f "$src" ] || [ -d "$src" ] |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 132 | then |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 133 | : |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 134 | else |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 135 | echo "$0: $src does not exist" >&2 |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 136 | exit 1 |
| 137 | fi |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 138 | |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 139 | if [ x"$dst" = x ] |
| 140 | then |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 141 | echo "$0: no destination specified" >&2 |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 142 | exit 1 |
| 143 | else |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 144 | : |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 145 | fi |
| 146 | |
| 147 | # If destination is a directory, append the input filename; if your system |
| 148 | # does not like double slashes in filenames, you may need to add some logic |
| 149 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 150 | if [ -d "$dst" ] |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 151 | then |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 152 | dst=$dst/`basename "$src"` |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 153 | else |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 154 | : |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 155 | fi |
| 156 | fi |
| 157 | |
| 158 | ## this sed command emulates the dirname command |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 159 | dstdir=`echo "$dst" | sed -e 's,[^/]*$,,;s,/$,,;s,^$,.,'` |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 160 | |
| 161 | # Make sure that the destination directory exists. |
| 162 | # this part is taken from Noah Friedman's mkinstalldirs script |
| 163 | |
| 164 | # Skip lots of stat calls in the usual case. |
| 165 | if [ ! -d "$dstdir" ]; then |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 166 | defaultIFS=' |
| 167 | ' |
| 168 | IFS="${IFS-$defaultIFS}" |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 169 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 170 | oIFS=$IFS |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 171 | # Some sh's can't handle IFS=/ for some reason. |
| 172 | IFS='%' |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 173 | set - `echo "$dstdir" | sed -e 's@/@%@g' -e 's@^%@/@'` |
| 174 | IFS=$oIFS |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 175 | |
| 176 | pathcomp='' |
| 177 | |
| 178 | while [ $# -ne 0 ] ; do |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 179 | pathcomp=$pathcomp$1 |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 180 | shift |
| 181 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 182 | if [ ! -d "$pathcomp" ] ; |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 183 | then |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 184 | $mkdirprog "$pathcomp" |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 185 | else |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 186 | : |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 187 | fi |
| 188 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 189 | pathcomp=$pathcomp/ |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 190 | done |
| 191 | fi |
| 192 | |
| 193 | if [ x"$dir_arg" != x ] |
| 194 | then |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 195 | $doit $instcmd "$dst" && |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 196 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 197 | if [ x"$chowncmd" != x ]; then $doit $chowncmd "$dst"; else : ; fi && |
| 198 | if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd "$dst"; else : ; fi && |
| 199 | if [ x"$stripcmd" != x ]; then $doit $stripcmd "$dst"; else : ; fi && |
| 200 | if [ x"$chmodcmd" != x ]; then $doit $chmodcmd "$dst"; else : ; fi |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 201 | else |
| 202 | |
| 203 | # If we're going to rename the final executable, determine the name now. |
| 204 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 205 | if [ x"$transformarg" = x ] |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 206 | then |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 207 | dstfile=`basename "$dst"` |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 208 | else |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 209 | dstfile=`basename "$dst" $transformbasename | |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 210 | sed $transformarg`$transformbasename |
| 211 | fi |
| 212 | |
| 213 | # don't allow the sed command to completely eliminate the filename |
| 214 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 215 | if [ x"$dstfile" = x ] |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 216 | then |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 217 | dstfile=`basename "$dst"` |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 218 | else |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 219 | : |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 220 | fi |
| 221 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 222 | # Make a couple of temp file names in the proper directory. |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 223 | |
| 224 | dsttmp=$dstdir/#inst.$$# |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 225 | rmtmp=$dstdir/#rm.$$# |
| 226 | |
| 227 | # Trap to clean up temp files at exit. |
| 228 | |
| 229 | trap 'status=$?; rm -f "$dsttmp" "$rmtmp" && exit $status' 0 |
| 230 | trap '(exit $?); exit' 1 2 13 15 |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 231 | |
| 232 | # Move or copy the file name to the temp name |
| 233 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 234 | $doit $instcmd "$src" "$dsttmp" && |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 235 | |
| 236 | # and set any options; do chmod last to preserve setuid bits |
| 237 | |
| 238 | # If any of these fail, we abort the whole thing. If we want to |
| 239 | # ignore errors from any of these, just make sure not to ignore |
| 240 | # errors from the above "$doit $instcmd $src $dsttmp" command. |
| 241 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 242 | if [ x"$chowncmd" != x ]; then $doit $chowncmd "$dsttmp"; else :;fi && |
| 243 | if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd "$dsttmp"; else :;fi && |
| 244 | if [ x"$stripcmd" != x ]; then $doit $stripcmd "$dsttmp"; else :;fi && |
| 245 | if [ x"$chmodcmd" != x ]; then $doit $chmodcmd "$dsttmp"; else :;fi && |
| 246 | |
| 247 | # Now remove or move aside any old file at destination location. We try this |
| 248 | # two ways since rm can't unlink itself on some systems and the destination |
| 249 | # file might be busy for other reasons. In this case, the final cleanup |
| 250 | # might fail but the new file should still install successfully. |
| 251 | |
| 252 | { |
| 253 | if [ -f "$dstdir/$dstfile" ] |
| 254 | then |
| 255 | $doit $rmcmd -f "$dstdir/$dstfile" 2>/dev/null || |
| 256 | $doit $mvcmd -f "$dstdir/$dstfile" "$rmtmp" 2>/dev/null || |
| 257 | { |
| 258 | echo "$0: cannot unlink or rename $dstdir/$dstfile" >&2 |
| 259 | (exit 1); exit |
| 260 | } |
| 261 | else |
| 262 | : |
| 263 | fi |
| 264 | } && |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 265 | |
| 266 | # Now rename the file to the real destination. |
| 267 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 268 | $doit $mvcmd "$dsttmp" "$dstdir/$dstfile" |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 269 | |
| 270 | fi && |
| 271 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 272 | # The final little trick to "correctly" pass the exit status to the exit trap. |
Wichert Akkerman | 76baf7c | 1999-02-19 00:21:36 +0000 | [diff] [blame] | 273 | |
Roland McGrath | 552cde2 | 2003-01-14 07:58:14 +0000 | [diff] [blame] | 274 | { |
| 275 | (exit 0); exit |
| 276 | } |